/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 

#include "menu.h"
#include <string.h>

int MENU_Load () {
	SDL_Surface *temp;
	struct TObject *p_obj;
	int i;
	
	// Lade Hintergrundbild in Screen_Backup
	if ( (temp = IMG_Load (MENU_GFX_BACKGROUND) ) < 0 ) return -1;
	back = SDL_DisplayFormat (temp);	
	// INfos ber den Menbereich eintragen
	MENU_Area.x = 0;
	MENU_Area.y = 0;
	MENU_Area.w = 800;
	MENU_Area.h = 200;
	// Registriere Hintergrund bild fr anzeige
	p_obj = VIDEO_CreateSurfaceObject(1, V_VISIBLE, back, NULL);
	VIDEO_RegisterObject(p_obj);
 
	
	// Setze pink = Transparent 
	SDL_SetColorKey (back, SDL_SRCCOLORKEY, SDL_MapRGB (back->format, 255, 0, 255));
	
	// Lade andere Grafiken 
	if ( (temp = IMG_Load (MENU_GFX_HIGHLIGHT) ) < 0 ) return -1;
	frame = SDL_DisplayFormat (temp);	
	SDL_SetColorKey (frame, SDL_SRCCOLORKEY, SDL_MapRGB (frame->format, 255, 0, 255));
	// Registriere Hintergrund bild fr anzeige
	p_obj = VIDEO_CreateSurfaceObject(3, V_INVISIBLE, frame, NULL);
	frame_index = VIDEO_RegisterObject(p_obj);
	
	txt_ln1 = VIDEO_TextOut (TITLE, 15, 25);
	
//	MAPED_Brush = -1; oboslet
//	MAPED_Brush_Type = -1;
	
	// Initialize Men - Array
	for (i=0; i< MENU_MENULEVEL * MENU_MENUENTRIES; i++) {
		menu[i].level = 0;
		menu[i].pos = 0;
		menu[i].text = NULL;
		menu[i].tile = NULL;
		menu[i].brush = NULL;
	}
	
	// Lade das Men Array aus Datei menu.descr
	if (MENU_LoadMenu (MENU_DESCR_FILE) == -1) {
		fprintf (stderr, "Kann Menbeschreibung menu.descr nicht laden\n");
		exit (-1);
	}

	// Grafiken des Menus aus dem Array anzeigen
	MAPED_ShowMenuButtons ();
	MENU_Selected_Index = -1;

	return 0;
}

// Lade die Mens aus der Datei Menu.descr
// Level
// Position
// Text
// Type des Tiles
// Index des Brushes der benutzt werden soll
// TODO: Indexwert in der Datei bercksichtigen - Brush ist noch gleich Tile
int MENU_LoadMenu (char *filename) {
	FILE *dat;
	int tmp_level, tmp_pos, tmp_index, tmp_x, tmp_y;
	char tmp_type[255], tmp_text[255];
	int index;

	dat = fopen (filename, "r");
	if (dat == NULL) return -1;
		
	printf ("\nLoading menu.descr.:\n");
	printf ("-------------------\n");
	index = 0;
	while ( EOF != fscanf(dat, "%i%i%i%i%s%s%i", &tmp_level, &tmp_pos, &tmp_x, &tmp_y, tmp_text, tmp_type, &tmp_index) ) {	

		menu[index].index = index;
		menu[index].level = tmp_level;
		menu[index].pos = tmp_pos;
		menu[index].x	= tmp_x;
		menu[index].y	= tmp_y;
		menu[index].text = (char *) malloc (strlen(tmp_text));
		strcpy(menu[index].text, tmp_text);
//		printf ("%s\n", tmp_type);
		if (strcmp(tmp_type, "GRAS_1") == 0) 
			menu[index].tile = (struct TTile *) MAP_GetTileByType (MT_GRAS_1);
		if (strcmp(tmp_type, "TREE_2") == 0) 
			menu[index].tile = (struct TTile *) MAP_GetTileByType (MT_TREE_2);
		if (strcmp(tmp_type, "WOODPICKER") == 0) 
			menu[index].tile = (struct TTile *) MAP_GetTileByType (MT_WOODPICKER);
		if (strcmp(tmp_type, "WAY_00") == 0) 
			menu[index].tile = (struct TTile *) MAP_GetTileByType (MT_WAY_00);
		if (strcmp(tmp_type, "HUNTER") == 0) 
			menu[index].tile = (struct TTile *) MAP_GetTileByType (MT_HUNTER);
		if (strcmp(tmp_type, "HOUSE_01") == 0) 
			menu[index].tile = (struct TTile *) MAP_GetTileByType (MT_HOUSE_01);

			
		menu[index].brush = menu[index].tile;
	
 		printf ("%i %i %s %s %i\n", menu[index].level, menu[index].pos, menu[index].text, tmp_type, tmp_index);			
		index++;
	}

	fclose (dat);
	printf ("-------------------\n");

	return 0;
}

// Show the menu buttons
void MAPED_ShowMenuButtons () {
	SDL_Rect ziel;
	struct TObject *p_obj;
	int i;
	
	i = 0;
	while (menu[i].level == MENU_LEVEL_1) {
		ziel.x = menu[i].x;
		ziel.y = menu[i].y;
		p_obj = VIDEO_CreateSurfaceObject (2, V_VISIBLE, MAP_GetTileImage (menu[i].tile->index) , &ziel);
		VIDEO_RegisterObject (p_obj);
		i++;
	}

	// update screen
	VIDEO_UpdateAll = TRUE;

} // ShowDesignButtons


// Handle a Mouse down event
int MAPED_MouseButton (SDL_MouseButtonEvent *e) {		
	switch (e->button) {
		case 1: 					// Linker Button
			MAPED_LeftButtonPressed = TRUE;
			if (MAPED_HandleLeftButton (e) != 0) return -1;
			break;
		case 2:						// Mittlerer Button
			break;
		case 3:						// Rechter Button
			MAPED_RightButtonPressed = TRUE;
			if (MAPED_HandleRightButton (e) != 0) return -1; 
			break;	
	
	} // switch

	return 0;
}

// Handle a button up event
int MAPED_MouseButtonUp (SDL_MouseButtonEvent *e) {
	switch (e->button) {
		case 1: 
			MAPED_LeftButtonPressed = FALSE;
			break;
		case 2:
			break;
		case 3:
			MAPED_RightButtonPressed = FALSE;
			break;	
	} // switch	
	
	return 0;
} // MouseButtonUp

// Handle left Mouse Button events
int MAPED_HandleLeftButton (SDL_MouseButtonEvent *e) {
	// detect is the click went into the menu or map area
	
//	printf ("%i %i %i %i\n", MENU_Area.x, MENU_Area.y, MENU_Area.w, MENU_Area.h);
	if ((e->x > MENU_Area.x)
	  	&& (e->y > MENU_Area.y)
		&& (e->x < MENU_Area.x + MENU_Area.w)
 		&& (e->y < MENU_Area.y + MENU_Area.h))
			MENU_HandleMenu (e);
	else
			MENU_HandleMap	(e);
	
	return 0;
}

// Handle clicks in the menu area
int MENU_HandleMenu (SDL_MouseButtonEvent *e) {
	int i;
	int sel_menu;

	// detect the selected button via the position
	i = 0;
	sel_menu = -1;
	while (menu[i].level == MENU_LEVEL_1) {
		if ((e->x > menu[i].x) 
			&& (e->y > menu[i].y) 
			&& (e->x < menu[i].x + menu[i].tile->img->w) 
			&& (e->y < menu[i].y + menu[i].tile->img->h)) {
				sel_menu = menu[i].index;
				break;
		} // if
		i++;
	} // while	

	// has something valid been chosen ?
	if (sel_menu == -1)  return -1; 

	// Draw a frame and memorize the selccted menu
	VIDEO_ChangeText (txt_ln1, menu[i].text, 15, 25);
	VIDEO_ShowObjectPos (frame_index, menu[sel_menu].x -2, menu[sel_menu].y-2); 
	MENU_Selected_Index = sel_menu;
	
	VIDEO_UpdateAll = TRUE;	
	return 0;

}

// Handle clicks on the map
int MENU_HandleMap	(SDL_MouseButtonEvent *e) {
	int map_index;
	struct TTile *brush;
	unsigned char zuf;

	if (MENU_Selected_Index == -1) return 0;
		
	map_index = MAP_GetTileforPos (e->x, e->y);
	if (map_index == -1) return 0;
			
	// gras:
	// get 1 random gras type
	if ((menu[MENU_Selected_Index].tile->type >= MT_GRAS_1) && (menu[MENU_Selected_Index].tile->type <= MT_GRAS_4)) {
		zuf = TOOLS_Random();
		if (zuf >0 && zuf <=64)  {
	      	brush = (struct TTile *) MAP_GetTileByType (MT_GRAS_1);
		} else if (zuf > 64 && zuf < 100) {
		    brush = (struct TTile *) MAP_GetTileByType (MT_GRAS_2);
		} else if (zuf > 100 && zuf < 200) {
      		brush = (struct TTile *) MAP_GetTileByType (MT_GRAS_3);
		} else {
      		brush = (struct TTile *) MAP_GetTileByType (MT_GRAS_4);
		}
	// trees
	} else if ((menu[MENU_Selected_Index].tile->type >= MT_TREE_1) && (menu[MENU_Selected_Index].tile->type <= MT_TREE_3)) {
		zuf = TOOLS_Random();
		if (zuf >0 && zuf <=80)  {
	      	brush = (struct TTile *) MAP_GetTileByType (MT_TREE_1);
		} else if (zuf > 80 && zuf < 160) {
		    brush = (struct TTile *) MAP_GetTileByType (MT_TREE_2);
		} else 
      		brush = (struct TTile *) MAP_GetTileByType (MT_TREE_3);
	// Special case: ways
	} else if ((menu[MENU_Selected_Index].tile->type >= MT_WAY_00) && (menu[MENU_Selected_Index].tile->type <= MT_WAY_15)) {
		brush = (struct TTile *) MAP_CreatePath (map_index);				
	} else
		brush = (struct TTile *) MAP_GetTileByType (menu[MENU_Selected_Index].brush->type);


	// set the tile
	MAP_SetTileIndex (map_index, brush->index, TRUE);
			
	VIDEO_UpdateMap = TRUE;

	return 0;
} // MENU_HandleMap


// Events Right Mousebutton
int MAPED_HandleRightButton (SDL_MouseButtonEvent *e) {
	return 0;
} // HandleRightButton


// Motion Events, triggerd by Right Mouse button and mouse movement:
// Handles Move-On-Motion: Move the map 
// and Draw-on-Mouse: Draw a brush wihle moving over the map
int MAPED_MouseMotion (SDL_MouseMotionEvent *e) {
	//int north;
	struct TTile *brush; 
	int map_index;
	unsigned char zuf;
	
	// check is any motion events are activated
	if ((MOVE_ON_MOUSE == 0) && (PAINT_ON_MOUSE == 0)) return 0;
	
	// move map via mouse 
	if (MOVE_ON_MOUSE && MAPED_RightButtonPressed) {	
		if (e->xrel > 0) MAP_MoveRight(1);
		if (e->xrel < 0) MAP_MoveLeft(1);		
		if (e->yrel > 0) MAP_MoveDown(1);
		if (e->yrel < 0) MAP_MoveUp(1);		
		VIDEO_UpdateMap = TRUE;
		return 0;
	}

	// draw per Motion
	// do it when activated by flag, the left mouse button is pressed and a brush is selected
	
	if (PAINT_ON_MOUSE == FALSE) return -1;
	if (e->state == SDL_RELEASED) return -1;
	if (MAPED_LeftButtonPressed == FALSE) return -1;
	if (MENU_Selected_Index == -1) return -1;
		
	if ((map_index = MAP_GetTileforPos (e->x, e->y)) == -1) return -1;	// Tile der Karte

	if ((menu[MENU_Selected_Index].tile->type >= MT_GRAS_1) && (menu[MENU_Selected_Index].tile->type <= MT_GRAS_4)) {
		zuf = TOOLS_Random();
		if (zuf >0 && zuf <=64)  {
	      	brush = (struct TTile *) MAP_GetTileByType (MT_GRAS_1);
		} else if (zuf > 64 && zuf < 100) {
		    brush = (struct TTile *) MAP_GetTileByType (MT_GRAS_2);
		} else if (zuf > 100 && zuf < 200) {
      		brush = (struct TTile *) MAP_GetTileByType (MT_GRAS_3);
		} else {
      		brush = (struct TTile *) MAP_GetTileByType (MT_GRAS_4);
		}
	} else if ((menu[MENU_Selected_Index].tile->type >= MT_TREE_1) && (menu[MENU_Selected_Index].tile->type <= MT_TREE_3)) {
		zuf = TOOLS_Random();
		if (zuf >0 && zuf <=80)  {
	      	brush = (struct TTile *) MAP_GetTileByType (MT_TREE_1);
		} else if (zuf > 80 && zuf < 160) {
		    brush = (struct TTile *) MAP_GetTileByType (MT_TREE_2);
		} else  
      		brush = (struct TTile *) MAP_GetTileByType (MT_TREE_3);
	// Special case: ways
	} else if ((menu[MENU_Selected_Index].tile->type >= MT_WAY_00) && (menu[MENU_Selected_Index].tile->type <= MT_WAY_15)) {
		brush = (struct TTile *) MAP_CreatePath (map_index);
	} else
		brush = (struct TTile *) MAP_GetTileByType (menu[MENU_Selected_Index].brush->type);

	// setze das Tile
	MAP_SetTileIndex (map_index, brush->index, TRUE);				// put brush onto map
		
	VIDEO_UpdateMap = TRUE;

	return 0;
} // MouseMotion
